// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "3dGfx.h", created on 15/06/99.
 * descr : declarations of some tables, variables to 3d gfx
 */
// ----------------------------------------------------------------------------------

#ifndef _3dGfxH
#define _3dGfxH
// ----------------------------------------------------------------------------------
extern float
  *tan_table,*inv_tan_table,   // tangent tables used to compute initial intersections with ray
  *y_step,*x_step,         // x and y steps, used to find intersections after initial one is found
  *cos_table,              // used to cacell out fishbowl effect
  *inv_cos_table,*inv_sin_table; // used to compute distances by calculating the hypontenuse
inline int fixUp(float deg_angle) { return (int)(deg_angle*32); }
inline int fixUp(int   deg_angle) { return deg_angle << 5; }

// ----------------------------------------------------------------------------------
extern int * lightTables;
extern unsigned char * lightDatas;
const int maxLightTab=6000;

// ----------------------------------------------------------------------------------
// map constans
// cells are curently 256x256
const int cellFP = 8;
const int cellSize= 1 << cellFP;
const int cellMaskUp=0xffffffff << cellFP;
const int cellMaskDown=~cellMaskUp;
const int overboard=20*cellSize/64;  // the closest a player can get to a wall
const int vScale = 13312*cellSize/64;

const int floorFP=9;
const int floorSize= 1 << floorFP;
const int floorMaskUp=0xffffffff << floorFP;
const int floorMaskDown=~floorMaskUp;

// ----------------------------------------------------------------------------------
extern int windowHeight, windowWidth;
// ----------------------------------------------------------------------------------

#endif // _3dGfxH




