// ----------------------------------------------------------------------------------
/* [z-11 project]
 * (c) 1999 Copyright Malekith
 * <malekith@topnet.pl> <http://malekith.topnet.pl>
 * For info about copying see file copying.z11.
 *
 * file "z11.h", created on 15/06/99.
 * descr : main include file, #included into all project files
 * also contains debug stuff, OkStuff() macro to validate state of classes,
 */
// ----------------------------------------------------------------------------------

#ifndef z11H
#define z11H

#include "defines.h" // all #defines go here

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <strstream.h>
#include "XStr.h"
#include "Xcpt.h"

// warning: #includes may be also at the end of this file, since some of
// them needs some stuff from here

// ----------------------------------------------------------------------------------
// debug stuff
extern FILE * dbg;
FILE * debugFile();
#define dm(a , args... ) ({if(debug) fprintf(debugFile(), a"\n" , ## args ); })
extern bool debug;
// ----------------------------------------------------------------------------------
#define OkStuff(a) \
  bool OK() { return id==a; } \
  void setId() { id=a; } \
  void test() { if(!OK()) haltx("id test failed (0x%lx)",this); } \
  int id

// ----------------------------------------------------------------------------------
// isn't that nice ? ;(
inline XStr cnd(char*ptr) return r(ptr) { delete ptr; }
#define xprintf(args...) cnd( ((ostrstream*) &(ostrstream().form(args) << '\0')) -> str() )
// ----------------------------------------------------------------------------------
#define VERSION  "5"
#define FILEINFO(fileid) char * fileinfo ## fileid = "$ Project: z-11 v " VERSION " (" __DATE__ \
                 " " __TIME__ ") file: " __FILE__ " (c) 1999 by Malekith $"
extern char version[];
// ----------------------------------------------------------------------------------
// this are from "bcnt.exe" pseudo compiler
// or incver.sh on Linux
extern int buildNo;
extern char * buildTime;
// ----------------------------------------------------------------------------------
extern int frame;
// ----------------------------------------------------------------------------------
typedef unsigned char byte;
const int maxInt = 0x7fffffff; // why not values.h ? don't like upper case
const short maxShort = 0x7fff;
const byte maxByte = 0xff;
// ----------------------------------------------------------------------------------
#ifdef AllegroTimer
  typedef int timer_t;
  const timer_t ups = 200; // timer rate
  extern volatile timer_t timerD;
  inline timer_t timer() { return timerD; }
#else
# ifdef DJGPP
  // clock() tics rather slow under dos ...
  typedef uclock_t timer_t;
  const timer_t ups = UCLOCKS_PER_SEC;
  inline timer_t timer() { return uclock(); }
  extern void delay(unsigned msec);
  inline void rest(int msec) {
    timer_t t=timer();
      while( (timer()-t) < (timer_t)msec*ups/1000 ) { }
  }
# else
  // but it runs fast enough under Linux
  typedef clock_t timer_t;
  const timer_t ups = CLOCKS_PER_SEC;
  inline timer_t timer() { return clock(); }
  extern void delay(unsigned msec);
  inline void rest(int msec) {
    timer_t t=timer();
    while( (timer()-t) < (timer_t)msec*ups/1000 ) { }
  }
# endif
#endif
// ----------------------------------------------------------------------------------
// utils
inline float frand(float max) { return random()*max/((float)maxInt+1); }
inline int   irand(int   max) { return random()%max; }
bool isIn(float v, const char * z);
template <class T> inline void swap(T & a, T & b) { T tmp=a; a=b; b=tmp; }
template <class T> inline T abs(const T & a) { if(a<0) return -a; else return a; }
#define sizeofT(x) ((int)(sizeof(x)/sizeof((x)[0])))
// ----------------------------------------------------------------------------------
// class used by string processing funcs, for use in Block<T>
// I like the way it's done in Borland C++ Builder -> strings in stringList has
// associeted objects, so I tried to do this the same way
// BTW: array of strings with associeted ptrs is most cases the most advanced
// data container I need
class Binder {
  public:
    XStr name;
    void * userData;
    bool operator == (const Binder & r) const
      { return downcase(name)==downcase(r.name); }
    Binder(XStr n = "", void * data = 0) : name(n), userData(data) { }
};
// ----------------------------------------------------------------------------------
extern XStr txtData, gfxData, lngData, dataPath;
// ----------------------------------------------------------------------------------

// ----------------------------------------------------------------------------------
#include "Block.h"
// ----------------------------------------------------------------------------------
#endif // z11H




